/**
 * \file    Mimic_Boolean.cpp
 * \author  Silvan Murer
 * \date    13 October 2022
 *
 * \brief   Boolean class of genSDK GF implementation, based on Mimic_Node
 */

#include "features/Mimic_Boolean.hpp"
#include "Mimic_Exception.hpp"

#define GENICAM_NO_AUTO_IMPLIB
#include "GenICam.h"

#include <memory>
#include <string>

using namespace GenApi;

namespace mimic {

    Mimic_Boolean::Mimic_Boolean() : Mimic_Node() { type = Type_e::BOOLEAN; };
    Mimic_Boolean::Mimic_Boolean(GenApi_3_4::INode* node) : Mimic_Node(node) { type = Type_e::BOOLEAN; };
    Mimic_Boolean::~Mimic_Boolean() { };

    std::variant<int64_t, double, bool, std::string> Mimic_Boolean::getVariant(std::string name)
    {
        return getValue();
    };
    void Mimic_Boolean::setVariant(std::string name, std::variant<int64_t, double, bool, std::string> value)
    {
        try {
            setValue(std::get<bool>(value));
        }
        catch (std::bad_variant_access const& e) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is of type Boolean! " + e.what(), -650);
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " read failed!", -610);
        }

    }

    bool Mimic_Boolean::getValue()
    {
        if (!IsImplemented(node) || !IsAvailable(node) || !IsReadable(node)) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is not readable!", -600);
        }
        try {
            return dynamic_cast<IBoolean*>(node)->GetValue();
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " read failed!", -610);
        }
    }
    void Mimic_Boolean::setValue(bool value)
    {
        if (!IsImplemented(node) || !IsAvailable(node) || !IsWritable(node)) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is not writable!", -600);
        }
        try {
            return dynamic_cast<IBoolean*>(node)->SetValue(value);
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " write failed!", -610);
        }
    }

} /* namespace genSDK */
